[SWUST1752] 运输问题(费用流)

题目链接:https://www.oj.swust.edu.cn/problem/show/1752

搞法如图:

  1 #include <bits/stdc++.h>
  2 using namespace std;
  3
  4 typedef long long LL;
  5 typedef struct Node {
  6     int u, v, next;
  7     LL c, w;
  8 }Node;
  9 const int maxn = 440;
 10 const int maxm = 80010;
 11 const LL mod = 0x3f3f3f3fLL;
 12 const LL inf = (1LL<<55);
 13 int tot, head[maxn];
 14 LL dist[maxn];
 15 LL cost, flow;
 16 Node e[maxm];
 17 int pre[maxn];
 18 bool visit[maxn];
 19 queue<int> Q;
 20 int S, T, N;
 21
 22 void init() {
 23     S = T = N = 0;
 24     memset(head, -1, sizeof(head));
 25     tot = 0;
 26 }
 27
 28 void adde(int u, int v, LL c, LL w) {
 29     e[tot].u = u; e[tot].v = v; e[tot].c = c; e[tot].w = w; e[tot].next = head[u]; head[u] = tot++;
 30     e[tot].u = v; e[tot].v = u; e[tot].c = 0; e[tot].w = -w; e[tot].next = head[v]; head[v] = tot++;
 31 }
 32 bool spfa(int s, int t, int n) {
 33     int i;
 34     for(i = 0; i <= n; i++) {
 35         dist[i] = inf;
 36         visit[i] = 0;
 37         pre[i] = -1;
 38     }
 39     while(!Q.empty()) Q.pop();
 40     Q.push(s);
 41     visit[s] = true;
 42     dist[s] = 0;
 43     pre[s] = -1;
 44     while(!Q.empty()) {
 45         int u = Q.front();
 46         visit[u] = false;
 47         Q.pop();
 48         for(int j = head[u]; j != -1; j = e[j].next) {
 49             if(e[j].c > 0 && dist[u] + e[j].w < dist[e[j].v]) {
 50                 dist[e[j].v] = dist[u] + e[j].w;
 51                 pre[e[j].v] = j;
 52                 if(!visit[e[j].v]) {
 53                     Q.push(e[j].v);
 54                     visit[e[j].v] = true;
 55                 }
 56             }
 57         }
 58     }
 59     if(dist[t] == inf) return false;
 60     else return true;
 61 }
 62 LL ChangeFlow(int t) {
 63     LL det = mod;
 64     int u = t;
 65     while(~pre[u]) {
 66         u = pre[u];
 67         det = min(det, e[u].c);
 68         u = e[u].u;
 69     }
 70     u = t;
 71     while(~pre[u]) {
 72         u = pre[u];
 73         e[u].c -= det;
 74         e[u ^ 1].c += det;
 75         u = e[u].u;
 76     }
 77     return det;
 78 }
 79 LL MinCostFlow(int s, int t, int n) {
 80     LL mincost, maxflow;
 81     mincost = maxflow = 0;
 82     while(spfa(s, t, n)) {
 83         LL det = ChangeFlow(t);
 84         mincost += det * dist[t];
 85         maxflow += det;
 86     }
 87     cost = mincost;
 88     flow = maxflow;
 89     return mincost;
 90 }
 91
 92 int n, m;
 93 int a[maxn], b[maxn], w[maxn][maxn];
 94
 95 int main() {
 96     // freopen("in", "r", stdin);
 97     while(~scanf("%d%d",&n,&m)) {
 98         init();
 99         S = 0, T = n + m + 1, N = T + 1;
100         for(int i = 1; i <= n; i++) scanf("%d", &a[i]);
101         for(int i = 1; i <= m; i++) scanf("%d", &b[i]);
102         for(int i = 1; i <= n; i++) {
103             for(int j = 1; j <= m; j++) {
104                 scanf("%d", &w[i][j]);
105             }
106         }
107         for(int i = 1; i <= n; i++) adde(S, i, a[i], 0);
108         for(int i = 1; i <= m; i++) adde(i+n, T, b[i], 0);
109         for(int i = 1; i <= n; i++) {
110             for(int j = 1; j <= m; j++) {
111                 adde(i, n+j, inf, w[i][j]);
112             }
113         }
114         cout << MinCostFlow(S, T, N) << endl;
115         init();
116         S = 0, T = n + m + 1, N = T + 1;
117         for(int i = 1; i <= n; i++) adde(S, i, a[i], 0);
118         for(int i = 1; i <= m; i++) adde(i+n, T, b[i], 0);
119         for(int i = 1; i <= n; i++) {
120             for(int j = 1; j <= m; j++) {
121                 adde(i, n+j, inf, -w[i][j]);
122             }
123         }
124         cout << -MinCostFlow(S, T, N) << endl;
125     }
126     return 0;
127 }
时间: 2024-10-09 14:10:07

[SWUST1752] 运输问题(费用流)的相关文章

运输问题(费用流)

//http://www.cnblogs.com/IMGavin/ #include <iostream> #include <stdio.h> #include <cstdlib> #include <cstring> #include <queue> #include <vector> #include <map> #include <stack> #include <set> #include

【费用流】【网络流24题】【cogs 739】运输问题

739. [网络流24题] 运输问题 ★★ 输入文件:tran.in 输出文件:tran.out 简单对比 时间限制:1 s 内存限制:128 MB ?问题描述: ?编程任务: 对于给定的m 个仓库和n 个零售商店间运送货物的费用,计算最优运输方案和最差运输方案. ?数据输入: ?结果输出: 程序运行结束时,将计算出的最少运输费用和最多运输费用输出到文件tran.out中. 输入文件示例 输出文件示例 tran.in 2 3 220 280 170 120 210 77 39 105 150 1

【网络流24题】No.19 负载平衡问题 (费用流)

[题意] G 公司有 n 个沿铁路运输线环形排列的仓库, 每个仓库存储的货物数量不等. 如何用最少搬运量可以使 n 个仓库的库存数量相同.搬运货物时,只能在相邻的仓库之间搬运. 输入文件示例input.txt517 9 14 16 4 输出文件示例output.txt11 [分析] 其实我觉得这题可以贪心啊..n^2贪心??.没细想.. 打的是费用流.. 大概这样建图: 懒得写了..凌乱之美.. 求满流费用.. 1 #include<cstdio> 2 #include<cstdlib&

POJ 3422 kaka&#39;s matrix trvals(费用流)

#include <iostream> #include <cstring> #include <cstdio> #include <cstdlib> #include <algorithm> #include <vector> #include <queue> #include <stack> #include <set> #include <map> #include <cma

hdu 2448 Mining Station on the Sea【网络费用流】

Mining Station on the Sea Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2371    Accepted Submission(s): 732 Problem Description The ocean is a treasure house of resources and the development

POJ训练计划3422_Kaka&#39;s Matrix Travels(网络流/费用流)

解题报告 题目传送门 题意: 从n×n的矩阵的左上角走到右下角,每次只能向右和向下走,走到一个格子上加上格子的数,可以走k次.问最大的和是多少. 思路: 建图:每个格子掰成两个点,分别叫"出点","入点", 入点到出点间连一个容量1,费用为格子数的边,以及一个容量∞,费用0的边. 同时,一个格子的"出点"向它右.下的格子的"入点"连边,容量∞,费用0. 源点向(0,0)的入点连一个容量K的边,(N-1,N-1)的出点向汇点连一

POJ 2135 Farm Tour &amp;&amp; HDU 2686 Matrix &amp;&amp; HDU 3376 Matrix Again 费用流求来回最短路

累了就要写题解,最近总是被虐到没脾气. 来回最短路问题貌似也可以用DP来搞,不过拿费用流还是很方便的. 可以转化成求满流为2 的最小花费.一般做法为拆点,对于 i 拆为2*i 和 2*i+1,然后连一条流量为1(花费根据题意来定) 的边来控制每个点只能通过一次. 额外添加source和sink来控制满流为2. 代码都雷同,以HDU3376为例. #include <algorithm> #include <iostream> #include <cstring> #in

【BZOJ3502/2288】PA2012 Tanie linie/【POJ Challenge】生日礼物 堆+链表(模拟费用流)

[BZOJ3502]PA2012 Tanie linie Description n个数字,求不相交的总和最大的最多k个连续子序列. 1<= k<= N<= 1000000. Sample Input 5 2 7 -3 4 -9 5 Sample Output 13 题解:跟1150和2151差不多. 我们先做一些预处理,因为连续的正数和连续的负数一定是要么都选要么都不选,所以可以将它们合并成一个数,同时区间中的零以及左右两端的负数没有意义,可以将它们删掉.然后我们得到的序列就变成:正-

POJ 2195 Going Home(费用流)

http://poj.org/problem?id=2195 题意: 在一个网格地图上,有n个小人和n栋房子.在每个时间单位内,每个小人可以往水平方向或垂直方向上移动一步,走到相邻的方格中.对每个小人,每走一步需要支付1美元,直到他走入到一栋房子里.每栋房子只能容纳一个小人. 计算出让n个小人移动到n个不同的房子需要支付的最小费用. 思路: 源点和每个人相连,容量为1,费用为0. 汇点和每栋房子相连,容量为1,费用为0. 每个人和每栋房子相连,容量为1,费用为人和房子之间的距离. 这样一来,跑一

洛谷P3381——费用流模板题

嗯..随便刷了一道费用流的模板题....来练练手. #include<iostream> #include<cstdio> #include<cstring> using namespace std; int h[5210],d[5210],used[5210],que[100010],last[5210]; int k=1,INF=0x7fffffff,ans1=0,ans2=0; inline int read(){ int t=1,num=0; char c=ge